/*
    $Id: SSTPQueue.java,v 1.2 2003/07/03 04:10:35 admin Exp $
    -----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package core;
import core.*;
import gui.main.*;
import com.apple.cocoa.foundation.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;

public class SSTPQueue extends Thread {
    private int interval = 1000; // bɑB
    
    Vector queue;
    private volatile boolean signal_stop = false;
    private volatile boolean signal_sleep = false;
    
    public SSTPQueue() {
        queue = new Vector();
    }
    
    public void run() {
	int pool = NSAutoreleasePool.push();
	
        MainWindowController.sharedInstance().setBottlesInQueueCount(0);

	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	Pattern pat_ifghost = Pattern.compile("^IfGhost\\s*:\\s*(.*)$");

	int pool_local = Integer.MIN_VALUE; // S͕ȂcB
        while (!signal_stop) {
	    if (pool_local != Integer.MIN_VALUE) {
		NSAutoreleasePool.pop(pool_local);
	    }
	    pool_local = NSAutoreleasePool.push();
	    
            // L[󂾂X[v肵
            if (signal_sleep || queue.size() <= 0) {
                try {
		    // ׌y
                    sleep(10 * 1000);
                }
                catch (InterruptedException e) {}
                continue;
            }
            
            // ɃvbVꂽNGXgɑB
            Vector req = (Vector)queue.elementAt(0);
            Vector resp = Foundation.sharedFoundation().sendToLocalSstpd(req);
            
            if (resp == null) {
		// ʐMG[Ȃ̂Œ߂B
		//queue.remove(0);
		//MainWindowController.sharedInstance().setBottlesInQueueCount(queue.size());
		
		// 2003/02/16 - ߂ȂB
                continue;
            }
            
	    /*
	      204܂200ł΁ÂŃfL[ėǂB
	      503 Service Unavailableł΁AݒɂĂ͑փS[XgĂɍđB
	      409ȊÕG[ȂA߂ăfL[ėǂB
	      409ꍇ̂݁AfL[Ă͂ȂȂB
	    */
            String first_line = (resp.size() == 0 ? "" : (String)resp.elementAt(0));
	    if (first_line.indexOf("503") != -1) {
		// ݒ擾B
		switch (defaults.integerForKey("sstp-error.503.select")) {
		case 0:
		    // ߂
		    queue.removeElementAt(0);
		    break;

		case 1:
		    // փS[Xg֑B
		    String ghostname = (String)defaults.objectForKey("sstp-error.503.substitution");
		    if (ghostname == null) {
			ghostname = "-UNINSTALLED-";
		    }
		    // IfGhost̍sTĒuւBΒǉB
		    boolean replaced = false;
		    boolean drop_this = false;
		    for (int i = 0; i < req.size(); i++) {
			String line = (String)req.get(i);
			Matcher m;
			if ((m = pat_ifghost.matcher(line)).find()) {
			    // IfGhostsłB
			    if (m.group(1).equals(ghostname)) {
				// ꂩ瑗炤ƂĂփS[XgẴ{głB
				drop_this = true;
			    }
			    else {
				req.set(i, "IfGhost: "+ghostname);
				replaced = true;
			    }
			    break;
			}
		    }
		    if (drop_this) {
			queue.removeElementAt(0);
		    }
		    else {
			if (!replaced) {
			    req.add("IfGhost: "+ghostname);
			}
			continue;
		    }
		    break;

		default:
		    queue.removeElementAt(0);
		}
	    }
	    else if (first_line.indexOf("409") == -1) {
		queue.removeElementAt(0);
            }
            MainWindowController.sharedInstance().setBottlesInQueueCount(queue.size());
            
            try {
                sleep(interval);
            }
            catch (InterruptedException e) {}
        }
	if (pool_local != Integer.MIN_VALUE) {
	    NSAutoreleasePool.pop(pool_local);
	}
        
        MainWindowController.sharedInstance().setBottlesInQueueCount(-1);
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate() {
        if (!isAlive()) return;
        
        signal_stop = true;
        interrupt();
        while (isAlive()) {}
    }
    
    public void push(Vector request) {
        if (!isAlive()) return;
        
        queue.add(request);
        MainWindowController.sharedInstance().setBottlesInQueueCount(queue.size());
        interrupt(); // vbVꂽƂɋCÂB
    }
    
    public void setSleeping(boolean val) {
        signal_sleep = val;
        if (isAlive()) interrupt(); // ԂωƂɋCÂB
    }
    
    public void clear() {
	queue.clear();
	MainWindowController.sharedInstance().setBottlesInQueueCount(0);
    }
}
