/*
	$Id: InstalledActionsTableDataSource.java,v 1.1 2003/07/03 04:10:35 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui.pref;
import action.*;
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class InstalledActionsTableDataSource implements NSTableView.DataSource
{
    private static InstalledActionsTableDataSource _shared;

    public static InstalledActionsTableDataSource sharedDataSource() {
	if (_shared == null) {
	    _shared = new InstalledActionsTableDataSource();
	}
	return _shared;
    }

    private InstalledActionsTableDataSource() {
    }
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
	try {
	    return ActionManager.sharedManager().getInstalledActions().size();
	}
	catch (Exception e) {
	    e.printStackTrace();
	    return 0;
	}
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return false;
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
	try {
	    BottleAction action = (BottleAction)ActionManager.
		sharedManager().getInstalledActions().get(rowIndex);
	    String ident = (String)aTableColumn.identifier();
	    
	    if (ident.equals("type")) {
		return ActionManager.getName(action);
	    }
	    else if (ident.equals("configuration")) {
		return action.getConfiguration();
	    }
	    else if (ident.equals("status")) {
		return action.getStatus();
	    }
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
	    
	return null;
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        // do nothing
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation)
    {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard)
    {
        // optional
        return false;
    }
}
