/*
	$Id: LogDataServer.java,v 1.3 2003/07/03 04:10:35 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log;
import log.*;
import gui.logbrowser.*;
import com.apple.cocoa.foundation.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.util.regex.*;
import java.net.*;

public class LogDataServer extends Thread
{
    protected static LogDataServer _sharedInstance = null;
    public static String home = NSPathUtilities.stringByExpandingTildeInPath("~");
	public static final int CACHE_SIZE = 7;
	public static final int AUTO_COMMIT_INTERVAL = 120 * 1000; // 2Ɏcommit
    
	LogData holded = null; // cacheƈႢAǂo鎖́B
    Vector cache; // <LogData>
    
    public static LogDataServer sharedLogServer()
    {
        if (_sharedInstance == null)
        {
            _sharedInstance = new LogDataServer();
			_sharedInstance.start();
        }
        return _sharedInstance;
    }
    
    protected LogDataServer()
    {
        cache = new Vector();
    }
	
	public void run() {
		while (true) {
			try {
				sleep(AUTO_COMMIT_INTERVAL);
			} catch (Exception e) {}
			
			commitAll();
		}
	}
	
	public LogData hold(int year,int month,int day) {
		unhold();
		holded = get(year,month,day);
		return holded;
	}
	
	public void unhold() {
		if (holded != null) {
			holded.commit();
		}
		holded = null;
	}
	
	public LogData getHolded() {
		return holded;
	}
	
	public LogData get(int year,int month,int day) {
		// holdĂAԂB
		if (holded != null &&
			holded.getYear() == year &&
			holded.getMonth() == month &&
			holded.getDay() == day) {
			
			return holded;
		}
		
		// cacheɓĂAԂB
		for (Enumeration e = cache.elements(); e.hasMoreElements(); ) {
			LogData log = (LogData)e.nextElement();
			if (log.getYear() == year &&
				log.getMonth() == month &&
				log.getDay() == day) {
				
				return log;
			}
		}
		
		// ĂȂB
		LogData new_log = new LogData(year,month,day);
		cacheThis(new_log);
		return new_log;
	}
    
    protected void cacheThis(LogData log)
	{
		// cacheɓĂA擪ɈړB
		// ĂȂ΁ALbVtȂŌ̍ڂĐ擪ɒǉB
		int cached_pos = cache.indexOf(log);
		if (cached_pos == -1) {
			if (cache.size() >= CACHE_SIZE) {
				// OcommitB
				LogData last = (LogData)cache.elementAt(cache.size()-1);
				last.commit();
				cache.remove(cache.size()-1);
			}
		}
		else {
			cache.remove(cached_pos);
		}
		cache.add(0,log);
	}
	
	public void commitAll()
	{
		// LbVĂSẴOcommitB
		if (holded != null) {
			holded.commit();
		}
		
		synchronized (cache) {
			for (Enumeration e = cache.elements(); e.hasMoreElements(); ) {
				LogData log = (LogData)e.nextElement();
				log.commit();
			}
		}
	}
	
    public void broadcastLog(String script,String channel,String mid,String uid,String ghost,String ifghost)
    {
        submit(LogData.LOG_ALL,script,channel,null,mid,uid,ghost,ifghost);
    }
    
    public void sendBroadcastLog(String script,String channel,String ghost,String ifghost)
    {
        submit(LogData.LOG_USER,script,channel,null,null,null,ghost,ifghost);
    }
    
    public void unicastLog(String script,String uid)
    {
        // ƂƂdlB
    }
    
    public void forceBroadcastLog(String script,String mid,String uid,String message)
    {
		submit(LogData.LOG_ADMIN,script,null,message,mid,uid,null,null);
    }
    
    private void submit(int type, String script, String channel, String fbmsg,
			String mid, String uid, String ghost, String ifghost) {
        // ̓t擾āÃt@C
        // p[^́Anull̕͏ȗꂽ̂ƌȂB
        // GR[h͂ȂœnĂB
	Calendar cal = Calendar.getInstance();
	int year = cal.get(Calendar.YEAR);
	int month = cal.get(Calendar.MONTH) + 1;
	int day = cal.get(Calendar.DAY_OF_MONTH);
	int hour = cal.get(Calendar.HOUR_OF_DAY);
	int minute = cal.get(Calendar.MINUTE);
	int second = cal.get(Calendar.SECOND);
	
	// ̃O擾
	LogData log_of_today = get(year,month,day);
        
        /*
	  logt@Č`F
	  type:[^Cv],script:[XNvg],...
	  ̂悤ɁAx:f[^,x:f[^,...ƂԂŏd˂ĂAf[^ɂĈsƂȂB
	  ΕKvtB[h͏ȗėǂAOt@Č`ςĂΉłB
          
          
	  xF
	  type: UB / OB / UU / OU / FB ̂ǂꂩBꂼAUser Broadcasted / Others Broadcasted / User Unicasted / Others Unicasted / ForceBroadcastedB̃vgRłunicastłł悤ɂȂ肻B
	  script: ShiftJIS + www-form-url-encodedŃGR[hꂽSakuraScript
	  channel: scriptƓGR[hŃ`l
	  mid: GR[hKvȂ悤AÔwww-form-url-encodedłMID
	  date: MMDDYYYY l
	  time: HHMMSS 24ԕ\L
	  fbmsg: scriptƓGR[hForceBroadcast̃_CAObZ[W
	  uid: GR[hKvȂ悤AÔwww-form-url-encodedłUID
	  ghost: scriptƓGR[hŃS[Xg
	  ifghost: scriptƓGR[hIfGhostiMłGhostj̎w
	  vote: l
	  agree: l
        */
        Hashtable bottle = new Hashtable();
	if (script != null) {
	    bottle.put("script",script);
	}
	if (channel != null) {
	    bottle.put("channel",channel);
	}
	if (mid != null) {
	    bottle.put("mid",mid);
	}
	bottle.put("date",(month <= 9 ? "0"+month : ""+month) + (day <= 9 ? "0"+day : ""+day) + year);
	bottle.put("time",(hour <= 9 ? "0"+hour : ""+hour) + (minute <= 9 ? "0"+minute : ""+minute) + (second <= 9 ? "0"+second : ""+second));
	if (fbmsg != null) {
	    bottle.put("fbmsg",fbmsg);
	}
	if (uid != null) {
	    bottle.put("uid",uid);
	}
	if (ghost != null) {
	    bottle.put("ghost",ghost);
	}
	if (ifghost != null) {
	    bottle.put("ifghost",ifghost);
	}

	/*
	// slppT[o[̃zXgƃ|[gĂBŎ擾Ƃӓ͎bB
	ServerConnection conn = Foundation.sharedFoundation().getSlppConnection();
	if (conn != null) {
	    bottle.put("slpp-server",conn.getSlppHost()+":"+conn.getSlppPort());
	}
	*/
	
	// ǉ
	log_of_today.add(type,bottle);
	
	// uEUŕ\̃t@Ĉ̂A[hB
	String pathOfBrowser = "/"+year+"/"+(month <= 9 ? "0"+month : ""+month)+"/"+(day <= 9 ? "0"+day : ""+day);
        LogBrowserController logBrowser = LogBrowserController.sharedLogBrowser();
        if (logBrowser.browserPath().equals(pathOfBrowser)) {
	    logBrowser.reloadTable();
	}
    }
    
	public static Vector logged_years()
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log");
        if (!parentdir.exists()) {
			return result;
		}
		
		// ÑfBNgƂċ
		Pattern pat = Pattern.compile("^\\d+$");
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			if (f.isDirectory() && pat.matcher(f.getName()).matches()) {
				result.add(f.getName());
			}
		}
		
		return result;
	}
	
	public static Vector logged_months(String year)
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log/"+year);
        if (!parentdir.exists()) {
			return result;
		}
		
		// ̃fBNgƂċ
		Pattern pat = Pattern.compile("^\\d+$");
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			if (f.isDirectory() && pat.matcher(f.getName()).matches()) {
				result.add(f.getName());
			}
		}
		
		return result;
	}
	
	public static Vector logged_days(String year,String month)
	{
		// ߂l: Vector<String>
		Vector result = new Vector();
		
		File parentdir = new File(home,"Library/BotCli/log/"+year+"/"+month);
        if (!parentdir.exists()) {
			return result;
		}
		
		// 01.log
		// 01.log.gz
		// 01.xml
		// 01.xml.gz
		// 01-extra.xml
		// 01-extra.xml.gz
		// ǂ̌`łǂAd΍폜B
		
		String gz = "(?:\\.gz)";
		Pattern pat = Pattern.compile("^(\\d+)(?:\\.log"+gz+"?|(?:-extra)?\\.xml"+gz+"?)$");
        
        File[] files = parentdir.listFiles();
		for (int i = 0; i < files.length; i++) {
			File f = files[i];
			
			if (f.isFile()) {
				Matcher matcher = pat.matcher(f.getName());
				if (matcher.find()) {
					result.add(matcher.group(1));
				}
			}
		}
		
		Vector uniq = new Vector();
		String last = null;
		for (Enumeration e = result.elements(); e.hasMoreElements(); )
		{
			String current = (String)e.nextElement();
			
			if (!current.equals(last)) {
				uniq.add(current);
				last = current;
			}
		}
		
		return uniq;
	}
}
