/*
	$Id: LogFileCompressor.java,v 1.2 2003/06/15 06:19:58 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2002 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log;
import log.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;
import java.util.regex.*;
import com.apple.cocoa.foundation.*;

/*
    Ƃ̑ÕO͈k܂B
*/

public class LogFileCompressor
{
    public static void compressOldFiles()
    {
		String user = NSPathUtilities.stringByExpandingTildeInPath("~");
		
		Calendar cal = Calendar.getInstance();
		int current_year = cal.get(Calendar.YEAR);
		int current_month = cal.get(Calendar.MONTH) + 1;
		int current_day = cal.get(Calendar.DAY_OF_MONTH);
		
		cal.roll(Calendar.DAY_OF_MONTH,-1); // ߂B
		int yesterday_year = cal.get(Calendar.YEAR);
		int yesterday_month = cal.get(Calendar.MONTH) + 1;
		int yesterday_day = cal.get(Calendar.DAY_OF_MONTH);
	
		Pattern pat = Pattern.compile("^(\\d+)(?:-extra)?\\.(?:log|xml)$");
		
		File logroot = new File(user,"Library/BotCli/log");
		if (!logroot.exists()) return;
		
		File[] years = logroot.listFiles();
		for (int i = 0;i < years.length;i++)
		{
			if (!years[i].isDirectory()) continue;
			int year = Integer.parseInt(years[i].getName());
			
			File[] months = years[i].listFiles();
			for (int j = 0;j < months.length;j++)
			{
				if (!months[j].isDirectory()) continue;
				int month = Integer.parseInt(months[j].getName());
				
				File[] days = months[j].listFiles();
				for (int k = 0;k < days.length;k++)
				{
					if (!days[k].isFile()) continue;
					Matcher matcher = pat.matcher(days[k].getName());
					if (matcher.find()) {
						try {
							int day = Integer.parseInt(matcher.group(1));
							
							if (!(year == current_year && month == current_month && day == current_day) &&
								!(year == yesterday_year && month == yesterday_month && day == yesterday_day)) {
								
								gzip(days[k]);
							}
						}
						catch (NumberFormatException e) {}
					}
					
					/*if (logfilename.charAt(0) == '.') continue;
					int day = Integer.parseInt(logfilename.substring(0,logfilename.indexOf('.')));
					
					if ((logfilename.endsWith(".log") || logfilename.endsWith(".xml")) &&
						!(year == current_year && month == current_month && day == current_day) &&
						!(year == yesterday_year && month == yesterday_month && day == yesterday_day))
					{
						gzip(days[k]);
					}*/
				}
			}
		}
    }
    
    public static void gzip(File src)
    {
		try
		{
			File dest = new File(src.getParent(),src.getName()+".gz");
			if (dest.exists()) dest.delete();
			
			FileInputStream fis = new FileInputStream(src);
			GZIPOutputStream gos = new GZIPOutputStream(new FileOutputStream(dest));
			
			byte[] buf = new byte[512];
			while (true)
			{
				int count = fis.read(buf);
				if (count == -1) break; // eof
				
				gos.write(buf,0,count);
			}
			
			fis.close();
			gos.close();
			
			src.delete();
		}
		catch (Exception e){}
    }
    
    public static void gunzip(File src)
    {
		try
		{
			File dest = new File(src.getParent(),NSPathUtilities.stringByDeletingPathExtension(src.getName()));
			if (dest.exists()) dest.delete();
			
			GZIPInputStream gis = new GZIPInputStream(new FileInputStream(src));
			FileOutputStream fos = new FileOutputStream(dest);
			
			byte[] buf = new byte[512];
			while (true)
			{
				int count = gis.read(buf,0,buf.length);
				if (count == -1) break; // eof
				
				fos.write(buf,0,count);
			}
			
			gis.close();
			fos.close();
			
			src.delete();
		}
		catch (Exception e){}
    }
	
	public static boolean haveToCompress(int year,int month,int day)
	{
		// ̓t̃OkׂǂB
		Calendar cal = Calendar.getInstance();
		int current_year = cal.get(Calendar.YEAR);
		int current_month = cal.get(Calendar.MONTH) + 1;
		int current_day = cal.get(Calendar.DAY_OF_MONTH);
		
		if (current_year == year &&
			current_month == month &&
			current_day == day) {
			
			return false;
		}
		
		cal.roll(Calendar.DAY_OF_MONTH,-1); // ߂B
		int yesterday_year = cal.get(Calendar.YEAR);
		int yesterday_month = cal.get(Calendar.MONTH) + 1;
		int yesterday_day = cal.get(Calendar.DAY_OF_MONTH);
		
		if (yesterday_year == year &&
			yesterday_month == month &&
			yesterday_day == day) {
			
			return false;
		}
		
		return true;
	}
}
