/*
	$Id: Httpd.java,v 1.2 2003/07/14 06:09:39 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2003 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log.logviewer;
import log.*;
import log.logviewer.*;
import java.net.*;
import java.io.*;
import util.*;
import com.apple.cocoa.foundation.*;

public class Httpd extends Thread {
    int port;
    ServerSocket ss;
    volatile boolean flag_term;
    
    public static final String resource_path = NSBundle.mainBundle().resourcePath();
    public static final TextTemplatePackage tmpl_index;
    static {
	tmpl_index = new TextTemplatePackage(
	    new File(resource_path,"logviewer-tmpl/index.html"),"UTF-8");
    }
    
    public static final String css_default;
    static {
	css_default = read_file(
	    new File(resource_path,"logviewer-tmpl/css/default.css"),"UTF-8");
    }
    
    public Httpd(int port) {
	this.port = port;
    }
    
    public void run() {
	try {
	    ss = new ServerSocket(port);
	    
	    while (!flag_term) {
		try {
		    Socket s = ss.accept();
		    
		    // [J[vobN̐ڑłȂΏRB
		    if (s.getInetAddress().isLoopbackAddress()) {
			new HttpSession(s).start();
		    }
		    else {
			s.close();
		    }
		}
		catch (SocketException ex) {
		    // server socketꂽ  I
		    break;
		}
		catch (Exception ex) {
		    ex.printStackTrace();
		}
	    }
	}
	catch (Exception e) {
	    //System.err.println(e.toString());
	    e.printStackTrace();
	}
    }

    public void terminate() {
	flag_term = true;
	try {
	    ss.close();
	} catch (Exception e) {}
	interrupt();
	while (isAlive()) {
	    try {
		Thread.sleep(150);
	    } catch (Exception e) {}
	}
    }
	
    public static String read_file(File f,String encoding) {
	StringBuffer result = new StringBuffer();
	
	try {
	    BufferedReader br = new BufferedReader(
		new InputStreamReader(
		    new FileInputStream(f),encoding));
	    while (true) {
		String line = br.readLine();
		if (line == null) {
		    break;
		}
		
		result.append(line).append("\n");
	    }
	}
	catch (Exception e) {
	    System.err.println("Couldn't read file "+f.getPath());
	    e.printStackTrace();
	}
	
	return result.toString();
    }

    public static boolean basicAuthEnabled() {
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	return defaults.integerForKey("http-log-browser.basic-auth.enabled") != 0;
    }

    public static String basicAuthValidID() {
	// id:passBase64GR[ĥԂB
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	String raw =
	    (String)defaults.objectForKey("http-log-browser.basic-auth.id") + ':' +
	    (String)defaults.objectForKey("http-log-browser.basic-auth.password");
	return Base64.encodeString(raw);
    }
}
