/*
	$Id: TextTemplatePackage.java,v 1.1.1.1 2003/04/08 14:55:47 admin Exp $
	-----
	
    SSTP Bottle Client for MacOS X, using protocol SLPP2.0
    Copyright (C) 2001-2003 phonohawk.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package log.logviewer;
import java.util.*;
import java.io.*;

public class TextTemplatePackage
{
	Hashtable templates;
	
	public TextTemplatePackage(File f,String encoding)
	{
		try {
			load(new FileInputStream(f),encoding);
		}
		catch (Exception e) {
			System.err.println("Couldn't read file "+f.getPath());
			e.printStackTrace();
		}
	}
	
	public TextTemplatePackage(InputStream is,String encoding)
	{
		try {
			load(is,encoding);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public TextTemplate get(String template_name) {
		TextTemplate tmpl = (TextTemplate)templates.get(template_name);
		return tmpl == null ? null : tmpl.copy();
	}
	
	protected void load(InputStream is,String encoding) throws Exception
	{
		templates = new Hashtable();
		
		BufferedReader br = new BufferedReader(new InputStreamReader(is,encoding));
		String current_name = null;
		StringBuffer current_content = new StringBuffer();
		while (true) {
			String line = br.readLine();
			if (line == null) {
				break;
			}
			
			if (line.startsWith("<!-- Template:")) {
				if (current_name != null) {
					templates.put(current_name,
								  new TextTemplate(current_content.toString()));
				}
				
				current_name = line.substring(line.indexOf(':')+1,
											  line.indexOf("-->")).trim();
				current_content.setLength(0);
			}
			else if (current_name != null) {
				current_content.append(line).append("\n");
			}
		}
		
		if (current_name != null) {
			templates.put(current_name,
						  new TextTemplate(current_content.toString()));
		}
	}
}
